/****************************************************************************
 *                  function.h
 *
 * This module contains all defines, typedefs, and prototypes for fnsyntax.c.
 *
 * This module is based on code by D. Skarda, T. Bily and R. Suzuki.
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: function.h,v $
 * $Revision: 1.8 $
 * $Author: chris $
 *
 *****************************************************************************/


#ifndef FUNCTION_H
#define FUNCTION_H

BEGIN_POV_NAMESPACE

typedef unsigned int FUNCTION;
typedef FUNCTION * FUNCTION_PTR;

FUNCTION_PTR Parse_Function(void);
FUNCTION_PTR Parse_FunctionContent(void);
FUNCTION_PTR Parse_DeclareFunction(int *token_id, char *fn_name, bool is_loca);
void Destroy_Function(FUNCTION_PTR Function);
FUNCTION_PTR Copy_Function(FUNCTION_PTR Function);

#define MAX_CALL_STACK_SIZE 1024

#ifdef MECHANICS_SIMULATION_PATCH            /* Christoph Hormann August 2002 */
  FUNCTION_PTR Parse_ParameterFunction(void);
  FUNCTION_PTR Parse_SplineFunction(void);
  FUNCTION_PTR Parse_PigmentFunction(void);
#endif
END_POV_NAMESPACE

#endif
