/****************************************************************************
 *                   fur.h
 *
 *  This module contains all functions for participating fur.
 *
 *  Thomas Willhalm 1999
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: fur.h,v $
 * $Revision: 1.9 $
 * $Author: chris $
 *
 *****************************************************************************/
#ifndef FUR_H
#define FUR_H

/*****************************************************************************
* Global preprocessor defines
******************************************************************************/
#ifdef FUR_PATCH
BEGIN_POV_NAMESPACE
/* Pattern types for fur */
#define SPHERE_FUR    1
#define TORUS_FUR     2
#define BOX_FUR       3
#define PLANE_FUR     4
#define SMOOTH_TRIANGLE_FUR 5
#define CYLINDER_FUR  6
#define CONE_FUR      7

/*****************************************************************************
* Global typedefs
******************************************************************************/

/*****************************************************************************
* Global variables
******************************************************************************/

/*****************************************************************************
* Global functions
******************************************************************************/

FUR *Create_Fur(void);
FUR *Copy_Fur(FUR *Old);
void Destroy_Fur(FUR *Fur);
void Transform_Fur(FUR *Fur, TRANSFORM *Trans);
DBL evaluate_fur_density(FUR *Fur, VECTOR EPoint, VECTOR Tangent);
END_POV_NAMESPACE

#endif
#endif
