/****************************************************************************
 *                  fvector.h
 *
 *  Author: Wlodzimierz ABX Skiba (abx@abx.art.pl)
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: fvector.h,v $
 * $Revision: 1.8 $
 * $Author: chris $
 *
 *****************************************************************************/


#ifndef FVECTOR_H
#define FVECTOR_H

#ifdef ALTERNATIVE_VECTOR_FUNCTION

#include "function.h"

BEGIN_POV_NAMESPACE

/*****************************************************************************
* Global typedefs
******************************************************************************/

typedef struct Vector_Function_Struct VECTOR_FUNCTION;

struct Vector_Function_Struct
{
  bool IsPigment;
  int InputDimension;
  int OutputDimension;
  union {
    FUNCTION_PTR Function[5];
    PIGMENT *Pigment;
  } Data;
};

/*****************************************************************************
* Global functions
******************************************************************************/

VECTOR_FUNCTION *Create_Vector_Function();
void Destroy_Vector_Function(VECTOR_FUNCTION *Vector_Function);
VECTOR_FUNCTION *Copy_Vector_Function(VECTOR_FUNCTION *Vector_Function);
void Compute_Vector_Function(VECTOR_FUNCTION *Vector_Function,DBL In[], DBL Out[]);

END_POV_NAMESPACE

#endif


#endif
