/****************************************************************************
 *                  glow.h
 *
 *  This module contains functions for the glow feature.
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: glow.h,v $
 * $Revision: 1.8 $
 * $Author: chris $
 *
 *****************************************************************************/

#ifdef GLOW_PATCH

#ifndef GLOW_H
#define GLOW_H

BEGIN_POV_NAMESPACE
/*****************************************************************************
* Global preprocessor defines
******************************************************************************/

/*This is defined in povray.h, uncommenting it causes a warning or error.
Maybe it should be defined in frame.h instead...
typedef GLOW * GLOW_PTR;*/

/*****************************************************************************
* Global typedefs
******************************************************************************/
struct Glow_Struct
{
    VECTOR Center;
    COLOUR Colour;
    int Glow_Type;
    DBL Size;
    DBL Cutoff_Radius;
    DBL fade_pow;
    TPATTERN * Warps;
    GLOW * next;
};

/*****************************************************************************
* Global variables
******************************************************************************/



/*****************************************************************************
* Global functions
******************************************************************************/

void Do_Glow(INTERSECTION * Isect, RAY * Ray, COLOUR Colour);
GLOW * Create_Glow();
void Add_Glow(GLOW * Glow);
void Destroy_Glow(GLOW * Glow);
void Destroy_Glow_List(GLOW * Glow_List);
void Parse_Glow(GLOW * Glow);
void Transform_Glow(GLOW * Glow, TRANSFORM * Trans);

END_POV_NAMESPACE

#endif
#endif
