/****************************************************************************
 *                  mblur.h
 *
 *  Written By Nathan Kopp - December, 1999
 *
 *  This module implements routines for motion blur.
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: mblur.h,v $
 * $Revision: 1.6 $
 * $Author: chris $
 *
 *****************************************************************************/

#ifndef MBLUR_H
#define MBLUR_H

BEGIN_POV_NAMESPACE

/*****************************************************************************
* Global preprocessor defines
******************************************************************************/

typedef struct motion_blur_Struct MOTION_BLUR;

struct motion_blur_Struct
{
  COMPOUND_FIELDS
};



/*****************************************************************************
* Global variables
******************************************************************************/

extern METHODS Motion_Blur_Methods;


/*****************************************************************************
* Global functions
******************************************************************************/

MOTION_BLUR *Create_Motion_Blur (void);
void Compute_Motion_Blur_BBox (OBJECT *Object);

END_POV_NAMESPACE

#endif
