/****************************************************************************
 *                  POLYSOLV.h
 *
 * This module contains all defines, typedefs, and prototypes for MATH.CPP.
 *
 * from Persistence of Vision(tm) Ray Tracer version 3.6.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2004 Persistence of Vision Raytracer Pty. Ltd.
 *---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 *---------------------------------------------------------------------------
 * This program is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 *---------------------------------------------------------------------------
 *
 *===========================================================================
 * This file is part of MegaPOV, a modified and unofficial version of POV-Ray
 * For more information on MegaPOV visit our website:
 * http://megapov.inetart.net/
 *===========================================================================
 *
 * $RCSfile: polysolv.h,v $
 * $Revision: 1.8 $
 * $Author: chris $
 *
 *****************************************************************************/


#ifndef POLYSOLV_H
#define POLYSOLV_H

BEGIN_POV_NAMESPACE

/*****************************************************************************
* Global preprocessor defines
******************************************************************************/

#define MAX_ORDER 15

#ifdef POLYNOMIAL_SOLVER_PATCH
  //#define USE_NEW_DIFFICULT_COEFFS
  //#define TEST_SOLVER
  #define POLYNOMIAL_PARAMS 2       /* sturm, epsilon */
  #define MIN_POLYNOMIAL_COEFFS 2   /* linear equation */
  #define MIN_POLYNOMIAL_PARAMS (MIN_POLYNOMIAL_COEFFS + POLYNOMIAL_PARAMS)
  #define MAX_POLYNOMIAL_COEFFS (MAX_ORDER + 1)
  #define MAX_POLYNOMIAL_PARAMS (MAX_POLYNOMIAL_COEFFS + POLYNOMIAL_PARAMS)
#endif

/*****************************************************************************
* Global typedefs
******************************************************************************/




/*****************************************************************************
* Global variables
******************************************************************************/

#ifdef POLYNOMIAL_SOLVER_PATCH
  extern DBL cached_polynomial_roots[MAX_ORDER];
#endif


/*****************************************************************************
* Global functions
******************************************************************************/

int Solve_Polynomial (int n, DBL *c, DBL *r, int sturm, DBL epsilon);

#ifdef POLYNOMIAL_SOLVER_PATCH
  int buffered_polynomial_solver(int n, DBL *params);
#endif

END_POV_NAMESPACE

#endif
